define([
    "dojo/when",
    "epi-cms/telemetry/trackProjects",
    "epi-cms/telemetry/tracker"
], function (
    when,
    trackProjects,
    tracker
) {
    function trackInlineMainButtonCommand(trackEventName, commandType, isSuccess) {
        trackProjects.getProjectState().then(function (isProjectSelected) {
            tracker.track("trackInlineMainButton", trackEventName, {
                commandType: commandType,
                isSuccess: isSuccess,
                isProjectSelected: isProjectSelected
            });
        });
    }

    function patchCommand(command, eventName) {
        var original_Execute = command.prototype._execute;
        command.prototype._execute = function (event) {
            var result = original_Execute.apply(this, arguments);
            when(result).then(function (executeResult) {
                trackInlineMainButtonCommand(eventName, this.commandType, !!executeResult);
            }.bind(this)).otherwise(function () {
                trackInlineMainButtonCommand(eventName, this.commandType, false);
            }.bind(this));
            return result;
        };
        command.prototype._execute.nom = "_execute";
    }

    function patchInlineCommands() {
        require([
            "epi-cms/contentediting/command/BlockInlineReadyForReview",
            "epi-cms/contentediting/command/BlockInlineReadyToPublish"
        ], function (
            BlockInlineReadyForReviewCommand,
            BlockInlineReadyToPublishCommand
        ) {
            patchCommand(BlockInlineReadyForReviewCommand, "Edit ReadyForReview");
            patchCommand(BlockInlineReadyToPublishCommand, "Edit ReadyToPublish");
        });
    }

    return {
        initialize: function () {
            patchInlineCommands();
        }
    };
});
