define([
    "dojo/_base/declare"
], function (
    declare
) {
    var _instance;
    return {
        track: function (origin, event, data) {
            _instance.track(origin, event, data);
        },
        initialize: function (telemetry, commonProperties) {
            var Tracker = declare(null, {
                constructor: function (telemetry) {
                    //Initialize Gainsight
                    var userFields = {
                        id: telemetry.user,
                        signUpDate: telemetry.user_creationDate
                    };
                    var accountFields = {
                        id: telemetry.client
                    };

                    // eslint-disable-next-line no-undef
                    aptrinsic("identify",
                        userFields,
                        accountFields
                    );
                },
                track: function (origin, event, data) {

                    if (typeof aptrinsic !== "function") {
                        return;
                    }

                    var log = { origin: origin };

                    if (typeof data === "string" || typeof data === "number" || typeof data === "boolean") {
                        data = {value: data};
                    }

                    if (data) {
                        log = Object.assign(log, data);
                    }

                    // eslint-disable-next-line no-undef
                    aptrinsic("track", event, log);
                }
            });
            if (!_instance) {
                _instance = new Tracker(telemetry);
            }
        }
    };
});
