define([
    "dojo/_base/declare",
    "./Block",
    "./ContentArea"
], function (
    declare,
    Block,
    ContentArea
) {

    var SingleBlock = declare([Block], {
        postCreate: function () {
            this.inherited(arguments);

            this.commandProvider.moveVisibleToPrevious.set("isAvailable", false);
            this.commandProvider.moveVisibleToNext.set("isAvailable", false);
            if (this.commandProvider.moveOutsideGroup) {
                this.commandProvider.moveOutsideGroup.set("isAvailable", false);
            }
            if (this.commandProvider.personalize) {
                this.commandProvider.personalize.set("isAvailable", false);
            }
        }
    });

    return declare([ContentArea], {
        // tags:
        //      internal xproduct

        blockClass: SingleBlock,

        onForceValueChange: function (property) {
            if (property && property.value) {
                if (property.value.length) {
                    property.value = property.value.length > 0 ? property.value[0] : null;
                    this.onValueChange(property);
                } else {
                    property.value = null;
                    this.onValueChange(property);
                }
            }
        },

        getFormattedValue: function (value) {
            return value ? [value] : value;
        },

        _setupBlocks: function () {
            this.inherited(arguments);

            this._toggleSelector();
        },

        _toggleSelector: function () {
            if (this.get("readOnly")) {
                return;
            }

            var isDisabled = (this.model.get("value") || []).length >= 1;
            this.actionsNode.classList.toggle("dijitHidden", isDisabled);
        }
    });
});
